import fetch from 'node-fetch';
import { isPackageSpec } from './package';
export async function DownloadText(fileUrl) {
    const res = await fetch(fileUrl);
    return await res.text();
}
export async function GetJsonBlob(url) {
    const blob = await DownloadText(url);
    const json = JSON.parse(blob);
    return json;
}
export async function GetPackages(url) {
    const blob = await GetJsonBlob(url);
    if (isPackageSpec(blob)) {
        return blob;
    }
}
