import { chkArrayOf, chkFieldType, chkObjectOf, chkObjectOfType, chkStrField, isString, } from '@freik/typechk';
const isPackagePair = chkObjectOfType({
    packager: isString,
    name: isString,
});
const isToolTriplet = chkObjectOfType({
    packager: isString,
    name: isString,
    version: isString,
});
const isPlatformEntry = chkObjectOfType({
    name: isString,
    architecture: isString,
    version: isString,
    category: isString,
    help: chkObjectOf(chkStrField('online')),
    url: isString,
    archiveFileName: isString,
    checksum: isString,
    size: isString,
    boards: chkArrayOf(chkStrField('name')),
    toolDependencies: isToolTriplet,
    discoveryDependencies: isPackagePair,
    monitorDependencies: isPackagePair,
});
const isToolSystemEntry = chkObjectOfType({
    size: isString,
    checksum: isString,
    host: isString,
    archiveFileName: isString,
    url: isString,
});
const isToolEntry = chkObjectOfType({
    name: isString,
    version: isString,
    systems: chkArrayOf(isToolSystemEntry),
});
const isPackageEntry = chkObjectOfType({
    name: isString,
    maintainer: isString,
    websiteURL: isString,
    email: isString,
    platforms: isPlatformEntry,
    tools: isToolEntry,
});
export const isPackageSpec = chkFieldType('packages', chkArrayOf(isPackageEntry));
